SystemOrganization addCategory: #ConfigurationOfArduino!

Object subclass: #ConfigurationOfArduino
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfArduino'!

!ConfigurationOfArduino commentStamp: 'Richo 2/22/2012 14:16' prior: 0!
Getting started:
------------------------

After installing the Arduino packages by evaluating...

	ConfigurationOfArduino load.
	
...you'll need a couple extra support files in order to be able to upload programs to your Arduino board. You can download them from here:
	
	http://www.mediafire.com/?1rep41uygl4rpf1
	
Extract the contents of that file in the same directory where you have your Pharo image.
Now you're ready to go. I suggest you start by looking at the Arduino class for examples, and the Arduino class comment for some code snippets.!

!ConfigurationOfArduino class methodsFor: 'development support' stamp: 'Richo 2/22/2012 13:06'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfArduino class methodsFor: 'private' stamp: 'Richo 2/22/2012 13:06'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfArduino class methodsFor: 'private' stamp: 'Richo 2/22/2012 13:06'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfArduino class methodsFor: 'private' stamp: 'Richo 2/22/2012 13:06'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfArduino class methodsFor: 'help' stamp: 'Richo 2/22/2012 14:18'!
helpGettingStarted
	^ (Smalltalk at: #HelpTopic)
		perform: #title:contents:
		with: 'Getting Started'
		with: self comment
! !

!ConfigurationOfArduino class methodsFor: 'metacello tool support' stamp: 'Richo 2/22/2012 13:06'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfArduino class methodsFor: 'loading' stamp: 'Richo 2/22/2012 13:06'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfArduino class methodsFor: 'loading' stamp: 'Richo 2/22/2012 13:06'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfArduino class methodsFor: 'loading' stamp: 'Richo 2/22/2012 13:06'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfArduino class methodsFor: 'accessing' stamp: 'Richo 2/22/2012 13:06'!
project

	^self new project! !

!ConfigurationOfArduino class methodsFor: 'development support' stamp: 'Richo 2/22/2012 13:06'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfArduino methodsFor: 'baselines' stamp: 'Richo 2/22/2012 13:43'!
baseline10: spec
	<version: '1.0-baseline'>
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/Arduino'.
		spec project: 'FFI' with: [
			spec
				className: 'ConfigurationOfFFI';
				versionString: '1.3';
				loads: #('ALL');
				file: 'ConfigurationOfFFI';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec project: 'CTranslator' with: [
			spec
				className: 'ConfigurationOfCTranslator';
				versionString: '1.0';
				loads: #('ALL');
				file: 'ConfigurationOfCTranslator';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec
			package: 'Arduino-Core';
			package: 'Arduino-Compiler' with: [
				spec requires: 'Arduino-Core';
					requires: 'CTranslator';
					requires: 'FFI']]! !

!ConfigurationOfArduino methodsFor: 'baselines' stamp: 'Richo 3/16/2012 14:01'!
baseline20: spec
	<version: '2.0-baseline'>
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/Arduino'.
		spec project: 'FFI' with: [
			spec
				className: 'ConfigurationOfFFI';
				versionString: '1.3';
				loads: #('ALL');
				file: 'ConfigurationOfFFI';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec project: 'OSProcess' with: [
			spec
				className: 'ConfigurationOfOSProcess';
				versionString: '4.4.5';
				loads: #('ALL');
				file: 'ConfigurationOfOSProcess';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec project: 'CTranslator' with: [
			spec
				className: 'ConfigurationOfCTranslator';
				versionString: '2.0';
				loads: #('ALL');
				file: 'ConfigurationOfCTranslator';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec
			package: 'Arduino-Core';
			package: 'Arduino-Compiler' with: [
				spec requires: 'Arduino-Core';
					requires: 'CTranslator';
					requires: 'FFI';
					requires: 'OSProcess']]! !

!ConfigurationOfArduino methodsFor: 'baselines' stamp: 'Richo 3/21/2012 15:28'!
baseline30: spec
	<version: '3.0-baseline'>
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/Arduino'.
		spec project: 'FFI' with: [
			spec
				className: 'ConfigurationOfFFI';
				versionString: '1.3';
				loads: #('ALL');
				file: 'ConfigurationOfFFI';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec project: 'OSProcess' with: [
			spec
				className: 'ConfigurationOfOSProcess';
				versionString: '4.4.5';
				loads: #('ALL');
				file: 'ConfigurationOfOSProcess';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec project: 'CTranslator' with: [
			spec
				className: 'ConfigurationOfCTranslator';
				versionString: #stable;
				loads: #('ALL');
				file: 'ConfigurationOfCTranslator';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec
			package: 'Arduino-Core';
			package: 'Arduino-Compiler' with: [
				spec requires: 'Arduino-Core';
					requires: 'CTranslator';
					requires: 'FFI';
					requires: 'OSProcess']]! !

!ConfigurationOfArduino methodsFor: 'accessing' stamp: 'Richo 2/22/2012 13:06'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfArduino methodsFor: 'symbolic versions' stamp: 'Richo 3/21/2012 15:29'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '3.0'.
! !

!ConfigurationOfArduino methodsFor: 'versions' stamp: 'Richo 2/22/2012 13:32'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec for: #common do: [
		spec
			package: 'Arduino-Core' with: 'Arduino-Core-Richo.31';
			package: 'Arduino-Compiler' with: 'Arduino-Compiler-Richo.40']! !

!ConfigurationOfArduino methodsFor: 'versions' stamp: 'Richo 3/16/2012 13:55'!
version20: spec
	<version: '2.0' imports: #('2.0-baseline')>
	spec for: #common do: [
		spec
			package: 'Arduino-Core' with: 'Arduino-Core-Richo.31';
			package: 'Arduino-Compiler' with: 'Arduino-Compiler-Richo.45']! !

!ConfigurationOfArduino methodsFor: 'versions' stamp: 'Richo 3/21/2012 15:29'!
version30: spec
	<version: '3.0' imports: #('3.0-baseline')>
	spec for: #common do: [
		spec
			package: 'Arduino-Core' with: 'Arduino-Core-Richo.31';
			package: 'Arduino-Compiler' with: 'Arduino-Compiler-Richo.47']! !
